summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorMaxim Devaev <[email protected]>2024-03-11 17:11:55 +0200
committerMaxim Devaev <[email protected]>2024-03-11 17:11:57 +0200
commit9e96772533a92ecd2a0f82825215acd5c5f50394 (patch)
treee63cb0a60586357aa6d62eb8e415efb508cf8e19
parent5274673ab6d61968b4927abaa52a9ed48428938c (diff)
Added kvmd-udev-restart pass and udev rule to restart kvmd-pass on plugging HDMI-A-1
https://forums.raspberrypi.com/viewtopic.php?p=2202017
-rw-r--r--PKGBUILD3
-rw-r--r--configs/os/udev/v4plus-hdmi-rpi4.rules1
-rwxr-xr-xscripts/kvmd-udev-restart-pass49
3 files changed, 53 insertions, 0 deletions
diff --git a/PKGBUILD b/PKGBUILD
index 74e6d560..8a4d6115 100644
--- a/PKGBUILD
+++ b/PKGBUILD
@@ -217,6 +217,9 @@ for _variant in "${_variants[@]}"; do
if [[ $_platform =~ ^.*-hdmiusb$ ]]; then
install -Dm755 -t \"\$pkgdir/usr/bin\" scripts/kvmd-udev-hdmiusb-check
fi
+ if [[ $_base == v4plus ]]; then
+ install -Dm755 -t \"\$pkgdir/usr/bin\" scripts/kvmd-udev-restart-pass
+ fi
install -DTm644 configs/os/sysctl.conf \"\$pkgdir/etc/sysctl.d/99-kvmd.conf\"
install -DTm644 configs/os/udev/common.rules \"\$pkgdir/usr/lib/udev/rules.d/99-kvmd-common.rules\"
diff --git a/configs/os/udev/v4plus-hdmi-rpi4.rules b/configs/os/udev/v4plus-hdmi-rpi4.rules
index 88ba66b1..87cfc700 100644
--- a/configs/os/udev/v4plus-hdmi-rpi4.rules
+++ b/configs/os/udev/v4plus-hdmi-rpi4.rules
@@ -4,3 +4,4 @@ KERNEL=="video[0-9]*", SUBSYSTEM=="video4linux", KERNELS=="fe801000.csi|fe801000
KERNEL=="hidg0", GROUP="kvmd", SYMLINK+="kvmd-hid-keyboard"
KERNEL=="hidg1", GROUP="kvmd", SYMLINK+="kvmd-hid-mouse"
KERNEL=="hidg2", GROUP="kvmd", SYMLINK+="kvmd-hid-mouse-alt"
+SUBSYSTEM=="drm", ACTION=="change", ENV{DEVLINKS}=="/dev/dri/by-path/platform-gpu-card", RUN+="/usr/bin/kvmd-udev-restart-pass %k %E{CONNECTOR}"
diff --git a/scripts/kvmd-udev-restart-pass b/scripts/kvmd-udev-restart-pass
new file mode 100755
index 00000000..21f3b9b9
--- /dev/null
+++ b/scripts/kvmd-udev-restart-pass
@@ -0,0 +1,49 @@
+#!/bin/bash
+# ========================================================================== #
+# #
+# KVMD - The main PiKVM daemon. #
+# #
+# Copyright (C) 2018-2023 Maxim Devaev <[email protected]> #
+# #
+# This program is free software: you can redistribute it and/or modify #
+# it under the terms of the GNU General Public License as published by #
+# the Free Software Foundation, either version 3 of the License, or #
+# (at your option) any later version. #
+# #
+# This program is distributed in the hope that it will be useful, #
+# but WITHOUT ANY WARRANTY; without even the implied warranty of #
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
+# GNU General Public License for more details. #
+# #
+# You should have received a copy of the GNU General Public License #
+# along with this program. If not, see <https://www.gnu.org/licenses/>. #
+# #
+# ========================================================================== #
+
+
+set -eE
+set -x
+
+# https://forums.raspberrypi.com/viewtopic.php?p=2202017
+
+card="$1"
+conn_id="$2"
+
+test -n "$card"
+test -n "$conn_id"
+
+card_n="${card/card/}"
+test -n "$card_n"
+
+port=$(grep "^connector\[$conn_id\]:" "/sys/kernel/debug/dri/$card_n/state" | awk '{print $1}')
+test -n "$port"
+
+
+if [ "$port" = "HDMI-A-1" ]; then
+ if systemctl is-enabled -q kvmd-pass; then
+ status=$(head -n 1 "/sys/class/drm/$card-$port/status")
+ if [ "$status" = "connected" ]; then
+ systemctl restart kvmd-pass || true
+ fi
+ fi
+fi